#ifndef RV_DEFS_H
#define RV_DEFS_H

#if defined (irix) || defined(OS_IRIX)

typedef unsigned char bool;

#endif

#define RV_REF_SOUND_SPEED	340.0	// m.s-1 (in air)

#define RV_T0 293.15
#define RV_PR 101.325
#define RV_ZERO_KELVIN -273.15
#define RV_RHO 1.2

#define RV_MONO               ((long)1)
#define RV_STEREO             ((long)2)
#define RV_QUAD               ((long)4)
#define RV_8CH                ((long)8)
#define RV_HEADPHONES         ((long)16)
#define RV_SPEAKERS           ((long)32)
#define RV_IITD               ((long)64)
#define RV_RENDER_MAP_DIRECT  ((long)128)
#define RV_RENDER_HRTF        ((long)256)
#define RV_AMBISONICS_DECODE  ((long)512)
#define RV_OMNI               ((long)1024)
#define RV_CARDIO             ((long)2048)
#define RV_BIPOLE             ((long)4096)
#define RV_HYPERCARDIO	((long)8192)
#define RV_SPEAKER	 	((long)16384)	
#define RV_RENDER_PAN         ((long)32768)
#define RV_MAP_MATRIX         ((long)65536)
#define RV_DISTANCE_CUE       ((long)131072)
#define RV_SUPERCARDIO       	((long)262144)
#define RV_VOICE       	((long)524288)

#define RV_MAX_WINDOWS	10

//#define RV_SOUND_EVENT_TYPE 0
//#define RV_MOTION_EVENT_TYPE 1

#ifdef _WIN32
#define CPU_LITTLE_ENDIAN
#endif
#ifdef irix
#define CPU_BIG_ENDIAN
#endif

#if defined (_WIN32) || defined (CPU_LITTLE_ENDIAN)
#define RV_RGBA2INT(r,g,b,a) ((unsigned int)(((int)(a*255)<<24)+((int)(b*255)<<16)+((int)(g*255)<<8)+(int)(r*255)))
#endif

#if defined (irix) || defined (CPU_BIG_ENDIAN)
#define RV_RGBA2INT(r,g,b,a) ((unsigned int)(((int)(r*255)<<24)+((int)(g*255)<<16)+((int)(b*255)<<8)+(int)(a*255)))
#endif


// Imported from RvDefs.h
//
#if defined (_WIN32) || defined (OS_WINDOWS)
#define CPU_LITTLE_ENDIAN
#include <stdlib.h>
#endif

#define RV_MIN(a,b) ( ((a)>=(b)) ? (b) : (a) )
#define RV_MAX(a,b) ( ((a)>=(b)) ? (a) : (b) )

#define RV_M_E             2.7182818284590452354
#define RV_M_LOG2E         1.4426950408889634074
#define RV_M_LOG10E        0.43429448190325182765
#define RV_M_LN2           0.69314718055994530942
#define RV_M_LN10          2.30258509299404568402
#define RV_M_PI            3.14159265358979323846
#define RV_M_2PI           ((double)(2.0*3.14159265358979323846))
#define RV_M_PI_2          1.57079632679489661923
#define RV_M_PI_4          0.78539816339744830962
#define RV_M_1_PI          0.31830988618379067154
#define RV_M_2_PI          0.63661977236758134308
#define RV_M_2_SQRTPI      1.12837916709551257390
#define RV_M_SQRT2         1.41421356237309504880
#define RV_M_SQRT2_2       0.70710678118654752440

#define RV_RAD2DEG(a) ( (double)(a*180.0/RV_M_PI))
#define RV_DEG2RAD(a) ( (double)(a*RV_M_PI/180.0))

#define RV_ROUND(a) ( ((a)>0.0) ((int)((a)+0.5)) : ((int)((a)-0.5)) )
#define RV_CLAMP(mi,ma,val) ( ((val)>=(ma)) ? (ma) : (((val)<=(mi)) ? (mi) : (val) ))

#define RV_NEXTPOW2(l) ( (aluint)(pow(2,ceil(log((l))/log(2)))) )


#endif
