#ifndef RV_DISPMAT_H
#define RV_DISPMAT_H

#ifdef OS_WINDOWS
	#include <windows.h>
	#include <winbase.h>
	#include <Vfw.h>
#endif

#include "RvVec.h"
#include "RvDefs.h"

//////////////////////////////////////////////////////////////////

struct RvDisplayMaterial {

  // Basic material
  RvVec4 ambient ;
  RvVec4 diffuse ;
  RvVec4 specular;
  RvVec4 emission;

  float shininess;
  float alpha;

  char *_name_;

  // Add field(s) for texture
  // ....



	RvDisplayMaterial();

	void setTexture(char *fname);
	void setTiffTexture(char *name, int mipm);

	void loadGL();
	void initGL();


	void update(float incr=1.0);

  	void load(char *fname);
  	void load();

protected:

};

#endif
