#include "RvGeom.h"
#include <GL/glut.h>
#include <assert.h>
#include <string.h>
#include <stdio.h>

bool RvBox::intersect( const RvRay &r, float &t1, float &t2 ) const {
  t1= -1e10, t2=1e10;
  float tmp1, tmp2;


  if (fabs(r.dir[0])>1e-6) {
    tmp1 = ( min[0] - r.origin[0] ) / r.dir[0];
    tmp2 = ( max[0] - r.origin[0] ) / r.dir[0];
    if ( tmp2 > tmp1 ) {
      if ( tmp1 > t1 ) t1 = tmp1;
      if ( tmp2 < t2 ) t2 = tmp2;
    }  else {
      if ( tmp2 > t1 ) t1 = tmp2;
      if ( tmp1 < t2 ) t2 = tmp1;
    }
  } else {
    if ( ( r.origin[0] < min[0] ) || ( r.origin[0] > max[0] ) )
      return false;
  }

  if ( fabs(r.dir[1])>1e-6 ) {
    tmp1 = ( min[1] - r.origin[1] ) / r.dir[1];
    tmp2 = ( max[1] - r.origin[1] ) / r.dir[1];
    if ( tmp2 > tmp1 ) {
      if ( tmp1 > t1 ) t1 = tmp1;
      if ( tmp2 < t2 ) t2 = tmp2;
    }  else {
      if ( tmp2 > t1 ) t1 = tmp2;
      if ( tmp1 < t2 ) t2 = tmp1;
    }
  } else {
    if ( ( r.origin[1] < min[1] ) || ( r.origin[1] > max[1] ) )
      return false;
  }

  if ( fabs(r.dir[2])>1e-6 ) {
    tmp1 = ( min[2] - r.origin[2] ) / r.dir[2];
    tmp2 = ( max[2] - r.origin[2] ) / r.dir[2];
    if ( tmp2 > tmp1 ) {
      if ( tmp1 > t1 ) t1 = tmp1;
      if ( tmp2 < t2 ) t2 = tmp2;
    }  else {
      if ( tmp2 > t1 ) t1 = tmp2;
      if ( tmp1 < t2 ) t2 = tmp1;
    }
  } else {
    if ( ( r.origin[2] < min[2] ) || ( r.origin[2] > max[2] ) )
      return false;
  }

  if ( t1 > t2 ) return false;

  return true;
}

int RvBox::intersect(const RvRay &r,RvVec &pos,RvVec &norm,
	float &d,int backf_cull)
{
	return 0;
}

float RvBox::distance(const RvVec &v)
{
	return 0;
}

void RvBox::draw(unsigned int RGBA)
{
        glDisable(GL_LIGHTING);
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_COLOR_MATERIAL);
        //glColor4f(1.0,0.0,0.0,1.0);
	unsigned char *rgba = (unsigned char *) (&RGBA);
        glColor4ubv(rgba);

        glBegin(GL_LINES);

		glVertex3f(min[0],min[1],min[2]);
		glVertex3f(max[0],min[1],min[2]);
		glVertex3f(min[0],max[1],min[2]);
		glVertex3f(max[0],max[1],min[2]);

		glVertex3f(min[0],min[1],max[2]);
		glVertex3f(max[0],min[1],max[2]);
		glVertex3f(min[0],max[1],max[2]);
		glVertex3f(max[0],max[1],max[2]);

		glVertex3f(min[0],min[1],min[2]);
		glVertex3f(min[0],max[1],min[2]);
		glVertex3f(max[0],min[1],min[2]);
		glVertex3f(max[0],max[1],min[2]);

		glVertex3f(min[0],min[1],max[2]);
		glVertex3f(min[0],max[1],max[2]);
		glVertex3f(max[0],min[1],max[2]);
		glVertex3f(max[0],max[1],max[2]);

		glVertex3f(min[0],min[1],min[2]);
		glVertex3f(min[0],min[1],max[2]);
		glVertex3f(min[0],max[1],min[2]);
		glVertex3f(min[0],max[1],max[2]);

		glVertex3f(max[0],min[1],min[2]);
		glVertex3f(max[0],min[1],max[2]);
		glVertex3f(max[0],max[1],min[2]);
		glVertex3f(max[0],max[1],max[2]);


        glEnd();
        //glEnable(GL_LIGHTING);

}
