#ifndef _OBJ_MTL_PARSER_
#define _OBJ_MTL_PARSER_

class objMtlSimpleVertex {
public:
	// vertex coordinates
	float xyz[3];
	// texture coordinates
	float uvw[3];
	// normal coordinates
	float n[3];
};

class objMtlSimpleMaterial {
public:
	float Ka[3], Ks[3], Kd[3], Kt[3];
	char *name, *texture_name;
	objMtlSimpleMaterial() {
		name = texture_name = 0;
	}
	objMtlSimpleMaterial& operator =(const objMtlSimpleMaterial& in_arg) { 
	  Ka[0]=in_arg.Ka[0];Ks[0]=in_arg.Ks[0];Kd[0]=in_arg.Kd[0];Kt[0]=in_arg.Kt[0]; 
	  Ka[1]=in_arg.Ka[1];Ks[1]=in_arg.Ks[1];Kd[1]=in_arg.Kd[1];Kt[1]=in_arg.Kt[1]; 
	  Ka[2]=in_arg.Ka[2];Ks[2]=in_arg.Ks[2];Kd[2]=in_arg.Kd[2];Kt[2]=in_arg.Kt[2]; 
	  name = new char[strlen(in_arg.name)+1];
	  strcpy(name, in_arg.name);
	  if( in_arg.texture_name ) {
		texture_name = new char[strlen(in_arg.texture_name)+1];
		strcpy(texture_name, in_arg.texture_name);
	  }
	  return *this;
	}
};


extern int objMtlReadModelFile( const char* , bool );
extern int objMtlNumPolys();
// allocates the index array -- caller must free
extern void objMtlGetIndices(int , unsigned int&, unsigned short int*&, int&);
// allocates vertex array -- caller must free
extern void objMtlGetVertices(unsigned int&, objMtlSimpleVertex*& );
extern objMtlSimpleMaterial* objMtlGetMaterialTable(int& tabsize);
extern int objMtlGetNumMeshes();
extern void objMtlGetFaceGroupExtent(int i, int& st, int& en);

#endif
